import { QueryClient } from '../core/queryClient';
import { Query, QueryState } from '../core/query';
import { QueryKey, QueryOptions } from '../core/types';
export interface DehydrateOptions {
    shouldDehydrateQuery?: ShouldDehydrateQueryFunction;
}
export interface HydrateOptions {
    defaultOptions?: QueryOptions;
}
interface DehydratedQuery {
    cacheTime: number;
    queryHash: string;
    queryKey: QueryKey;
    state: QueryState;
}
export interface DehydratedState {
    queries: DehydratedQuery[];
}
export declare type ShouldDehydrateQueryFunction = (query: Query) => boolean;
export declare function dehydrate(client: QueryClient, options?: DehydrateOptions): DehydratedState;
export declare function hydrate(client: QueryClient, dehydratedState: unknown, options?: HydrateOptions): void;
export {};
